#include <iostream.h>
#include <dos.h>
#include <stdlib.h>
#include "hardio.h"

// o 8255

#define PORTA 0
#define PORTB 1
#define PORTC 2
#define PCTRL 3

// 室 ᨣ

#define A0  1
#define A1  2
#define RST 4
#define WR  8

// 室 ᨣ

#define DI0 8
#define DI1 16
#define DI2 32
#define DI3 64
#define READY 128

//   89c2051

#define VPP0  1
#define VPP5  2
#define INC   4
#define PROG  8
#define HILO  16

unsigned port = 0x378;
char memory[2048];  //   ணࠬ

// -뢮 १ LPT-

inline void put_data( unsigned char d )
{
  outportb(port,d);
}

inline void put_ctrl( unsigned char d )
{
  outportb(port+2,d);
}

inline unsigned char get_status()
{
  return inportb(port+1);
}

// ணࠬ஢ 8255

inline void reset_8255()  //  8255
{
  put_ctrl( RST );
  delay(1);
  put_ctrl( 0 );
  delay(1);
}

inline void wr_8255( unsigned a, unsigned char b )  // 襬  8255
{
  a ^= 3;
  put_ctrl( (a&3) );  //   뢮
//  delay(1);
  put_ctrl( (a&3) );  //   뢮
//  delay(1);
  put_data( b );  // ⠢塞 
//  delay(1);
  put_ctrl( WR | (a&3) );  // 뢠
//  delay(1);
  put_ctrl( (a&3) );  // 堥
//  delay(1);
}

// ன 8255

inline mode_8255_wr()  //  
{
  wr_8255(PCTRL,128);
}

inline mode_8255_rd()  //  ⥭   A - ⨢
{
  wr_8255(PCTRL,144);
}

// ⥭  

unsigned char get_data()
{
  unsigned char d1,d2;

//  mode_8255_rd();
  wr_8255(1,VPP5|PROG);             // ⠥  ࠤ
////  delay(1);
  int i;
  for (i=0; i<100; i++);
  d1 = (get_status() >> 3) & 0x0F;
  wr_8255(1,VPP5|PROG|HILO);        // ⠥  ࠤ
////  delay(1);
  for (i=0; i<100; i++);
  d2 = (get_status() >> 3) & 0x0F;

  return d1 + (d2<<4);
}

//   89c2051

void reset_2051()  //  2051
{
  wr_8255(PORTB, VPP0|VPP5|PROG);  // RST -  0
  delay(20);
  wr_8255(PORTB, VPP5|PROG);  // RST -  5v
  delay(1);
}

void nextaddr()
{
  wr_8255(PORTB,10);  // INC -  ஢
//  delay(1);
  wr_8255(PORTB,14);  // INC - ᮪ ஢
//  delay(1);
  wr_8255(PORTB,10);  // INC -  ஢
//  delay(1);
}

void readsig( unsigned char& s1, unsigned char& s2, unsigned char& s3 )
{
  mode_8255_rd(); //  A  蠥 
  delay(10);
  wr_8255(PORTC,0);   //  ⥭ ᨣ
  delay(10);
  reset_2051();
  delay(10);
  s1 = get_data();
  delay(10);
  nextaddr();
  delay(10);
  s2 = get_data();
  delay(10);
  nextaddr();
  delay(10);
  s3 = get_data();
}

void readdata( unsigned char* buf )
{
  mode_8255_rd(); //  A  蠥 
  delay(10);
  wr_8255(PORTC,12);   //  ⥭ 
  delay(10);
  reset_2051();
  delay(10);
  cout << "⠥ ...\n"
   << "0000000011111111222222223333333344444444555555556666666677777777\n"
   << "02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE\n"
   << "0000000000000000000000000000000000000000000000000000000000000000\n";
  delay(10);
  for (int i=0; i<2048; i++)
     {
       buf[i] = get_data();
//       cout << hex << ": " << i << " : " << (unsigned)buf[i] << '\n';
       if (!(i&31))
         {
           cout << ".";
         }
       nextaddr();
     }
  cout << "\n";
}

void checkdata( unsigned char* buf )
{
  mode_8255_rd(); //  A  蠥 
  delay(10);
  wr_8255(PORTC,12);   //  ⥭ 
  delay(10);
  reset_2051();
  delay(10);
  cout << "஢塞 ...\n";
  for (int i=0; i<2048; i++)
     {
       unsigned char d1 = get_data();
       if ( buf[i] != d1 )
          cout << hex << ": " << i
               << " : " << (unsigned)buf[i]
               << " ⠫: " << (unsigned)d1 << '\n' << dec;
       if (!(i&31))
         {
           cout << ".";
         }
       nextaddr();
     }
  cout << "\n஢ઠ 祭.\n";
}

void chip_erase()
{
  cout << "ࠥ ᮤন  ணࠬ...\n";

  mode_8255_rd(); //  A  蠥 
  wr_8255(PORTC,1);   //  ࠭ 稯
  reset_2051();

  wr_8255(PORTB,PROG);  // 12   稯
  wr_8255(PORTB,0);     //  PROG
  delay(50);            //  20 
  wr_8255(PORTB,PROG);   // ࠥ PROG
  wr_8255(PORTB,PROG|VPP5);   // 몫砥 12 
}

unsigned writedata( unsigned char* buf )
{
//  chip_erase();

  mode_8255_wr(); //  A 
  delay(10);
  wr_8255(PORTC,14);   //   
  delay(10);
  reset_2051();
  delay(10);
  cout << "襬 ...\n"
   << "0000000011111111222222223333333344444444555555556666666677777777\n"
   << "02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE02468ACE\n"
   << "0000000000000000000000000000000000000000000000000000000000000000\n";
       wr_8255(PORTB,VPP5|PROG);  // 5v
  delay(10);
  for (int i=0; i<2048; i++)
     {
//       mode_8255_wr(); //  A 
       wr_8255(PORTA,buf[i]); // ⠢塞 
       wr_8255(PORTB,PROG);  //  12v
       wr_8255(PORTB,0);  //  PROG
//       delay(2);
       unsigned t;

       for (t=0; t<50000; t++)
         {
           if (!(get_status() & 128)) break;
         }
       if (t==50000)
         {
           cout << "\n ! : " << hex << (unsigned)i
                 << " : " << (unsigned)buf[i] << '\n';
           return 0;
         }

//        while (get_status() & 128);

       wr_8255(PORTB,PROG);  //  12v
       delay(1);

       if (!(i&31))
         {
           cout << ".";
         }
       nextaddr();
     }
       wr_8255(PORTB,VPP5|PROG);  // 5v
     cout << '\n';
     return 1;
}

unsigned writelock()
{
  mode_8255_wr(); //  A 
  delay(10);
  delay(10);
  reset_2051();
  delay(10);
  cout << "襬  ...\n";
  wr_8255(PORTB,VPP5|PROG);  // 5v
  delay(10);

  wr_8255(PORTC,15);   //   lockbit 1
  wr_8255(PORTB,PROG);  //  12v
  wr_8255(PORTB,0);  //  PROG
  delay(20);
  wr_8255(PORTB,PROG);  //  12v
  wr_8255(PORTC,3);   //   lockbit 2
  wr_8255(PORTB,0);  //  PROG
  delay(20);
  wr_8255(PORTB,PROG);  //  12v

  wr_8255(PORTB,VPP5|PROG);  // 5v

  return 1;
}


